#ifndef DIALOGGETALLFILES_H
#define DIALOGGETALLFILES_H

#include <QDialog>
#include <QProgressBar>
#include <QSpinBox>

#include "filedonwload.h"
#include "GMarchive.h"

namespace Ui {
class DialogGetAllFiles;
}

class DialogGetAllFiles : public QDialog
{
    Q_OBJECT

public:
    enum Mode { download, decompress};
    explicit DialogGetAllFiles( QWidget *parent = 0, Mode mode = download);
    ~DialogGetAllFiles();

private slots:
    void getAllFiles();
    void SetValuesAndFileNumber(int progressbarvalue, int spinboxvalue,QProgressBar *pb,QSpinBox *sb);
    void setValue(QString,int);
    void decompressAll();
    void setTotalSize(QString,int);
private:
    Ui::DialogGetAllFiles *ui;
    FileDonwload *m_wikiquote;
    FileDonwload *m_wiktionary;
    FileDonwload *m_firstname;
    FileDonwload *m_lexique;
    FileDonwload *m_fortune;
    FileDonwload *m_cities;
    GMArchive *m_archwikiquote;
    GMArchive *m_archwiktionary;
    GMArchive *m_archfirstname;
    GMArchive *m_archlexique;
    GMArchive *m_archfortune;
    GMArchive *m_archcities;
    void Download(FileDonwload *ptr, QString file,qlonglong size, QProgressBar *pgn,QSpinBox *sb);
    void Decompress(FileDonwload *ptr, QString file, QProgressBar *pgn,QSpinBox *sb);
};

#endif // DIALOGGETALLFILES_H
