#include "filedonwload.h"
#include "dialogconfiguration.h"
#include "GMarchive.h"

#include <QNetworkRequest>
#include <QNetworkReply>
#include <QFile>
#include <QSettings>
#include <QFileInfo>
#include <QDir>

FileDonwload::FileDonwload(QUrl url, qlonglong size, QProgressBar *pb, QSpinBox *sb, QObject *)
{
    m_network = new QNetworkAccessManager(this);
    connect ( m_network,SIGNAL(finished(QNetworkReply*)),this,SLOT(fileDownloaded(QNetworkReply *)));
    m_url=url;
    m_totalsize=size;
    m_progressbar=pb;
    m_spinbox=sb;
    m_size=0;
    QNetworkRequest request(url);
    request.setAttribute(QNetworkRequest::FollowRedirectsAttribute,true);
    m_reply=m_network->get(request);
    //connect(m_reply,SIGNAL(finished()),this,SLOT(fileDownloaded(QNetworkReply *)));
    connect(m_reply,SIGNAL(downloadProgress(qint64,qint64)),this,SLOT(followProgress(qint64,qint64)));
}

void FileDonwload::fileDownloaded(QNetworkReply *reply)
{
    QString filename=DialogConfiguration::getStorageDirectory()+"/"+m_url.fileName();
    QFile file(filename);
    file.open(QIODevice::WriteOnly);
    QByteArray ba;
    qint64 maxlen=2048;
    bool end=false;
    while (!end)
    {
        ba=reply->read(maxlen);
        file.write(ba);
        if ( ba.isEmpty()) end=true;
        m_size+=maxlen;
        emit reading(m_size);
    }
    file.close();
    QFileInfo fi(filename);
    GMArchive gma(filename);
    emit Downloaded(m_totalsize,gma.getFilesNumber(),m_progressbar,m_spinbox);
}

void FileDonwload::followProgress(qint64 received,qint64 )
{
    emit reading(received);
}
