/***************************************************************************
 *   Copyright (C) 2007 - 2014 by Gilles Maire   *
 *   Gilles@lesjetesdelencre.com
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CONFIGURATION_H
#define CONFIGURATION_H

#include <QDialog>
#include "ui_configuration.h"
#include <QtSql>
class configuration : public QDialog, private Ui::configuration
{
		Q_OBJECT

	public:
        configuration ( QWidget* parent = 0 );
		~configuration();
		QSqlDatabase dicodb ;
        QString AppPath;
        QString MotCherche;
        QString m_basename ;
        void setTranslator (QTranslator *systemtranslator,
                            QTranslator *applicationtranslator);

private :
        QStringList m_listStyle ;
        QStringList m_listDataStyle ;
        QTranslator *m_systemtranslator;
        QTranslator *m_applicationtranslator;

        int LanguageIndex(QString lang);
private slots:
		void configurationfile();
		void enregistrer();
        void ChangeStyle(int);
        void ChangeFont( QString );
        void ChangeTailleFont( int);
        void ChangeLanguage(int indexlang);
signals:
        void ReloadConfig();
        void SaveGeometry();
        void ChangeLanguages(QTranslator *systemlangage, QTranslator *appltranslator);

};
#endif

