#include "conjugaison.h"
#include <QHBoxLayout>
#include <QTextBrowser>
#include <QSqlQuery>
#include <QStringList>
#include <QDebug>


void conjugaison::AfficheConjugaison( QString Verbe )
{
	QString IndicatifPresent[6],IndicatifImparfait[6],IndicatifFutur[6],PasseSimple[6],
	PresentConditionnel[6],PresentSubjonctif[6],ImparfaitSubjonctif[6],ImperatifPresent[6],ParticipePresent[6];
	QStringList ParticipePasse;
    QString sql="SELECT ortho,genre FROM dico WHERE ( cgram = 'VER' and genre != '' and lemme = '"+Verbe+"')";
	QSqlQuery query(sql);
	while( query.next() )
	{
		QString genre=query.value(1).toString();
		QString mot=query.value(0).toString();
		if ( genre.at(0) == 'm' ||  genre.at(0) == 'f') { ParticipePasse<<query.value(0).toString(); }
		else {
		for ( int i=0;i< genre.length();i+=2)
		 {
			QChar lettre;
			int chiffre;
			lettre=genre.at(i+1);
			chiffre=genre.at(i).digitValue();
			if ( lettre == 'A')		 { IndicatifPresent[chiffre-1]=mot;}
			else if ( lettre == 'B') { IndicatifImparfait[chiffre-1]=mot;}
			else if ( lettre == 'C') { IndicatifFutur[chiffre-1]=mot;}
			else if ( lettre == 'D') { PasseSimple[chiffre-1]=mot;}
			else if ( lettre == 'E') { PresentConditionnel[chiffre-1]=mot;}
			else if ( lettre == 'F') { PresentSubjonctif[chiffre-1]=mot;}
			else if ( lettre == 'G') { ImparfaitSubjonctif[chiffre-1]=mot;}
			else if ( lettre == 'H') { ImperatifPresent[chiffre-1]=mot;}
			else if ( lettre == 'I') { ParticipePresent[chiffre-1]=mot;}
		 }
		}
	}

	QString HTML;
	HTML="<html><body><table cellspacing='5' >";
	HTML+="<TR><TH></TH><TH>Pr&eacute;sent</TH><TH>Imparfait</TH><TH>Futur</TH></TR>";
	for ( int i =0 ;i<6;i++) {
		HTML+="<TR><TH>"+Article(i+1,Verbe)+"</TH><TD>"+IndicatifPresent[i]+"</TD><TD>"+IndicatifImparfait[i]+"</TD><TD>"+IndicatifFutur[i]+"</TD></TR>";
	}
	HTML+="<TR><TH></TH><TH>Pass&eacute; simple</TH><TH>Pr&eacute;sent conditionnel</TH><TH>Pr&eacute;sent subjonctif</TH></TR>";
	for ( int i =0 ;i<6;i++) {
		HTML+="<TR><TH>"+Article(i+1,Verbe)+"</TH><TD>"+PasseSimple[i]+"</TD><TD>"+PresentConditionnel[i]+"</TD><TD>"+PresentSubjonctif[i]+"</TD></TR>";
	}
	HTML+="<TR><TH></TH><TH>Imparfait subjonctif</TH><TH>Imp&eacute;ratif pr&eacute;sent</TH><TH>Participe pr&eacute;sent</TH></TR>";
	for ( int i =0 ;i<6;i++) {
		HTML+="<TR><TH>"+Article(i+1,Verbe)+"</TH><TD>"+ImparfaitSubjonctif[i]+"</TD><TD>"+ImperatifPresent[i]+"</TD><TD>"+ParticipePresent[i]+"</TD></TR>";
	}
	HTML+="</table></body></html>";
	Zone->setHtml( HTML);

}

QString conjugaison::AfficheDefinition(QString verbe, QString ortho)
{
     QString sql="SELECT genre FROM dico WHERE ( cgram = 'VER' and genre != '' and lemme = '"+verbe+"' and ortho='"+ortho+"')";
     QSqlQuery query(sql);
     QString retour;
     while( query.next() )
     {
         QString genre=query.value(0).toString();

         if ( genre.at(0) == 'm' ||  genre.at(0) == 'f') { retour+=QString("<p>\n&diams; Participe passé du verbe %1").arg(verbe) ; }
         else {
         for ( int i=0;i< genre.length();i+=2)
          {

             QChar lettre;
             lettre=genre.at(i+1);
             if ( lettre == 'A') { retour+=AffichePersonne(genre.at(i))+QString::fromUtf8(" du présent du verbe %1 (indicatif)\n").arg(verbe);}
             else if ( lettre == 'B') { retour+=AffichePersonne(genre.at(i))+QString::fromUtf8("de l'imparfait de l'indicatif du verbe %1 (indicatif)\n").arg(verbe) ;}
             else if ( lettre == 'C') { retour+=AffichePersonne(genre.at(i))+QString::fromUtf8("du futur du verbe %1 (indicatif)\n").arg(verbe);}
             else if ( lettre == 'D') { retour+=AffichePersonne(genre.at(i))+QString::fromUtf8("du passé simple du verbe %1 (indicatif)\n").arg(verbe);}
             else if ( lettre == 'E') { retour+=AffichePersonne(genre.at(i))+QString::fromUtf8("du présent du verbe %1 (conditionnel)\n").arg(verbe);}
             else if ( lettre == 'F') { retour+=AffichePersonne(genre.at(i))+QString::fromUtf8("du présent du verbe %1 (subjonctif)\n").arg(verbe);}
             else if ( lettre == 'G') { retour+=AffichePersonne(genre.at(i))+QString::fromUtf8("de l'imparfait du verbe %1 (subjonctif)\n").arg(verbe);}
             else if ( lettre == 'H') { retour+=QString::fromUtf8("<p>\n&diams; imperatif présent du verbe %1\n").arg(verbe);}
             else if ( lettre == 'I') { retour+=QString::fromUtf8("<p>\n&diams; participe présent du verbe %1\n").arg(verbe);}
          }
         }
     }
     return QString(ortho+": "+retour);

}

QString conjugaison::AffichePersonne(QChar genre)
{
    if ( genre == '1' )
        return QString::fromUtf8("<p>\n&diams; première personne du singulier ");
    else if ( genre == '2' )
        return QString::fromUtf8("<p>\n&diams; deuxième personne du singulier ");
    else if ( genre == '3' )
        return QString::fromUtf8("<p>\n&diams; troisième personne du singulier ");
    else if ( genre == '4' )
        return QString::fromUtf8("<p>\n&diams; première personne du pluriel ");
    else if ( genre == '5' )
        return QString::fromUtf8("<p>\n&diams; deuxième personne du pluriel ");
    else if ( genre == '6' )
        return QString::fromUtf8("<p>\n&diams; troisième personne du pluriel ");
    else return(QString::fromUtf8(""));
 }

conjugaison::conjugaison()
{
	Panneau=new QWidget();
	Panneau->setObjectName(QString::fromUtf8("Conjugaison"));

	QHBoxLayout *horizontalLayout;
	Zone = new QTextBrowser(Panneau);
	Zone->setObjectName(QString::fromUtf8("Zone"));
	horizontalLayout = new QHBoxLayout(Panneau);
	horizontalLayout->setObjectName(QString::fromUtf8("horizontalLayout"));
	horizontalLayout->addWidget(Zone);

}


QString conjugaison::Article( int index, QString verbe)
{
	QString ret;
	if ( index == 2 ) ret= "tu " ;
	else if (index == 3) ret= "il ";
	else if (index == 4) ret="nous ";
	else if (index == 5) ret="vous ";
	else if (index == 6) ret="ils ";
	else if (index == 1) {
		if ( verbe.at(0) == 'a' ||verbe.at(0) == 'e' || verbe.at(0) == 'i' ||verbe.at(0) == 'o' ||verbe.at(0) == 'u'  ||verbe.at(0) == 'y' ||verbe.at(0) == 'h' )
		ret="j'";
		else ret="je ";
			}

	return ( ret);
}



