#include "formatage.h"
#include <QDebug>
#include <QSqlQuery>

formatage::formatage()
{
}

QString formatage::EtendChiffreVerbe ( QChar chiffre)
{
    QString de(chiffre);

    if ( chiffre == '1') return(QString::fromUtf8("Première personne "));
    else if ( chiffre == '2' ) return (QString::fromUtf8("Deuxième personne "));
    else if ( chiffre == '3' ) return (QString::fromUtf8("Troisième personne "));
    else if ( chiffre == '4' ) return (QString::fromUtf8("Quatrième personne "));
    else if ( chiffre == '5' ) return (QString::fromUtf8("Cinquième personne "));
    else if ( chiffre == '6' ) return (QString::fromUtf8("Sixième personne "));
    return("");
}


QString formatage::EtendLettreVerbe ( QChar lettre, QString verbe)
{

    if ( lettre == 'A' ) return (QString::fromUtf8("du présent de l'indicatif du verbe ")+verbe+"\n");
    else if ( lettre == 'B' ) return (QString::fromUtf8("de l'imparfait du verbe ")+verbe+"\n");
    else if ( lettre == 'C' ) return (QString::fromUtf8("du futur du verbe ")+verbe+"\n");
    else if ( lettre == 'D' ) return (QString::fromUtf8("du passé simple du verbe ")+verbe+"\n");
    else if ( lettre == 'E' ) return (QString::fromUtf8("du conditionnel present du verbe ")+verbe+"\n");
    else if ( lettre == 'F' ) return (QString::fromUtf8("du présent du subjonctif du verbe ")+verbe+"\n");
    else if ( lettre == 'G' ) return (QString::fromUtf8("de l'imparfait du subjonctif du verbe ")+verbe+"\n");
    else if ( lettre == 'H' ) return (QString::fromUtf8("de l'impératif présent du verbe ")+verbe+"\n");
    else if ( lettre == 'I' ) return (QString::fromUtf8("du participe présent du verbe $verbe ")+verbe+"\n");
    else if ( lettre == 'J' ) return (QString::fromUtf8("du participe passé du verbe ")+verbe+"\n");
    return("");

}

QString formatage::FormateGenre (QString genre)
{
    if ( genre == "m" ) { return ("masculin"); }
    else if  ( genre == "f" )  { return (QString::fromUtf8("féminin")) ;}
    else { return ("") ;}

}

QString formatage::FormateSyllabes ( QString nbsyllabes )
{
  if ( nbsyllabes.toInt() > 1 )  return (  nbsyllabes + " syllabes" ) ;
  else if ( nbsyllabes.toInt() == 1 )  return ( nbsyllabes + " syllabe") ;
  else {return("") ;}
}

QString formatage::SupprimeEtiquette ( QString Etiquette, QString definition)
{
   QString definitionretournee;
   QStringList list= definition.split("\n");
   bool trouve=false;
   foreach (QString ligne,list )
   {
       if ( ligne.startsWith(Etiquette))
       {
           trouve=true;
       }
       else if ( ligne.startsWith("==="))
       {
           trouve = false;
           definitionretournee+=ligne+"\n";
        }
       else if ( !  ligne.startsWith("==="))
       {
           if (! trouve )
            definitionretournee+=ligne+"\n";

        }

   }
   return ( definitionretournee);
}

QString formatage::ExtraitRubrique ( QString Etiquette, QString definition, QString *chaineretournee, QString titre)
{
    QString definitionretournee;
    QString chaine;
    QStringList list= definition.split("\n");
    if (!titre.isEmpty()) titre="<h4>"+titre+"</h4>";
    bool trouve=false;
    foreach (QString ligne,list )
    {
        if ( ligne.startsWith(Etiquette))
        {
            chaine=ligne+"\n";
            trouve=true;
        }
        else if ( ligne.startsWith("==="))
        {
            definitionretournee+=ligne+"\n";
            trouve=false;
        }
        else if ( ! ligne.startsWith("==="))
        {
            if (trouve )
              chaine+=ligne+"\n";
            else
             definitionretournee+=ligne+"\n";
        }
    }
    if ( ! chaine.isEmpty()) { chaine.replace(Etiquette,titre); }
    *chaineretournee+=chaine;
    return ( definitionretournee);
}

QString formatage::ExtraitFrancais(QString definition)
{
    QString chaineretournee;
    QStringList list= definition.split("\n");
    bool frenchstart=false;
    foreach (QString ligne,list )
    {
        if ( ligne.contains(QRegExp("== *\\{\\{langue")))
         {
            QRegExp re("==( +)\\{\\{langue\\|fr\\}\\}( +)==");
            if ( ligne.contains(re))
            {
                QString space1=re.cap(1);
                QString space2=re.cap(2);
                frenchstart=true;
                ligne=ligne.remove("=="+space1+"{{langue|fr}}"+space2+"==");
                chaineretournee+=ligne+"\n";
            }
            else
               if ( frenchstart)
               {
                   return chaineretournee;
               }
          }
        else chaineretournee+=ligne+"\n";
    }
    return chaineretournee;
}



QString formatage::MakeTitle(QString definition)
{
    QStringList liste= definition.split("\n");
    QString chaineretournee;
    foreach ( QString ligne, liste)
    {
//  === {{S|nom|fr|num=1}} ===
//  === {{S|verbe|fr}} ===
    QRegExp rh1("=+ *\\{\\{S\\|([^|]+)\\|fr[^}]*\\}\\} +=+");
    if (ligne.contains(rh1))
    {
        QString title=rh1.cap(1);
        ligne.replace(rh1,"<h3>"+UcFirst(title) +"</h3>");
    }
    chaineretournee+=ligne+"\n";
    }
    return chaineretournee;


}

QString formatage::FormateDefinition (QString mot,QString definition, QString ajout)
{
    Q_UNUSED(mot)


    QRegExp pluriel("''Pluriel +de'' +\\[*([a-zàâéèêëïôûùüâœæ]+)\\]*",Qt::CaseInsensitive);
    if ( definition.contains(pluriel))
    {
       QString definition1=definition.replace(pluriel,QString("Pluriel de %1").arg(pluriel.cap(1)));
       QSqlQuery q(QString("SELECT definition FROM definitions WHERE ortho='%1'").arg(pluriel.cap(1)));
       q.next();
       definition=QString("%1\n\n%2").arg(definition1).arg(q.value("definition").toString());
       qDebug()<<definition;
    }
    definition=ExtraitFrancais(definition);

    definition.replace("&lt;br\n/&gt;","\n");
    //definition.replace(QRegExp("\\{\\{([^|])+\\|\\}\\}"),"{{\\}}");

    // Suppression des étiquettes inutiles entre [[ ]]

    definition.replace(QRegExp("\\[\\[Image:[^]]+\\]\\]"),"");
    definition.replace(QRegExp("\\[\\[Fichier:[^]]+\\]\\]"),"");

    // [[en:xxx]
    definition.replace(QRegExp("\\[\\[[a-z]{2,3}:[^]]+\\]\\]"),"");


    // Suppression des commentaires de la forme <!commentaires>
    definition.replace (QRegExp("&lt;![^&]+&gt;"),"");
    //qDebug()<<"/"<<definition<<"!";


    //definition.replace (QRegExp("\\[\\[[^|\\]]+\\|"),"[[");

    // Suppression des caractères seuls entourés de {{ }}
    definition.replace("{{-}}","");
    definition.replace("{{(}}","");
    definition.replace("{{)}}","");

    // Flèches droites
    //definition.replace("##*","&rarr;");
    // Losanges
    definition.replace("\n##","\n&loz;");
    // Changements de paragraphe
    definition.replace("\n#*","\n");
    // Diamants
    definition.replace("\n#","\n&diams;");
    // Bullets
    definition.replace("\n::*","\n&bull;");
    // Losanges
    definition.replace("\n:*","\n&loz;");


    //definition.replace(QRegExp("\\(DAF[^)]*\\)"),"");
    //definition.replace(QRegExp("\\(pron\\|[^)]+\\)"),"");
    //definition.replace(QRegExp("\\(fr-inv\\|[^)]+\\)"),"");
    //definition.replace(QRegExp("\\(fr-verbe-flexion\\|[^)]+\\)"),"");

    //definition.replace(QRegExp("fr\\|num=\\d"),"fr");
    //definition.replace(QRegExp("== *\\(=fr=\\) *=="),"");
    //definition.replace(QRegExp("== *\\(=[^=]+=\\) *==.*"),"");
    //definition.replace(QRegExp("== *\\(=[^=]+=\\) *=="),"");
    //definition.replace(QRegExp("\\(voir[^)]+\\)"),"");

    //suppression de rubriques non utiles
    definition=SupprimeEtiquette("=== {{S|prononciation}} ===",definition);
    definition=SupprimeEtiquette("==== {{S|traductions}} ====",definition);
    definition=SupprimeEtiquette(QString::fromUtf8("===== {{S - traductions à trier}} ====="),definition);
    definition=SupprimeEtiquette(QString::fromUtf8("==== {{S|apparentés}} ===="),definition);
    definition=SupprimeEtiquette(QString::fromUtf8("=== {{S|références}} ==="),definition);
    definition=SupprimeEtiquette("==== {{S|synonymes}} ====",definition);
    definition=SupprimeEtiquette("===== {{S|note}} =====",definition);
    definition=SupprimeEtiquette("===== {{S|traductions à trier}} =====",definition);
    definition=SupprimeEtiquette("==== {{S|homophones}} ====",definition);
    definition=SupprimeEtiquette("=== {{S|voir aussi}} ===",definition);
    definition=SupprimeEtiquette("=== {{S|anagrammes}} ===",definition);
    definition=SupprimeEtiquette("==== {{S|hyperonymes}} ====",definition);
    definition=SupprimeEtiquette("==== {{S|hyponymes}} ====",definition);
    definition=SupprimeEtiquette("==== {{S|troponymes}} ====",definition);
    definition=SupprimeEtiquette("==== {{S|antonymes}} ====",definition);
    definition=SupprimeEtiquette("==== {{S|variantes ortho}} ====",definition);
    definition=SupprimeEtiquette("==== {{S|vocabulaire}} ====",definition);
    definition=SupprimeEtiquette("==== {{S|holonymes}} ====",definition);
    definition=SupprimeEtiquette(QString::fromUtf8("==== {{S|méronymes}} ===="),definition);
    definition=SupprimeEtiquette("==== {{S|paronymes}} ====",definition);
    definition=SupprimeEtiquette("==== {{S|variantes dialectales}} ====",definition);
    definition=SupprimeEtiquette(QString::fromUtf8("==== {{S|abréviations}} ===="),definition);
    definition=SupprimeEtiquette("==== {{S|quasi-synonymes}} ====",definition);
    definition=SupprimeEtiquette(QString::fromUtf8("==== {{S|dérivés autres langues}} ===="),definition);
    definition=SupprimeEtiquette("==== {{S|}} ====",definition);

    // extraction des rubriques etymologie et expression

    definition=ExtraitRubrique(QString::fromUtf8("=== {{S|étymologie}} ==="),definition,&m_etymologie);
    m_etymologie=FormateEtymologie(m_etymologie);
    definition=ExtraitRubrique("==== {{S|expressions}} ====",definition,&m_expression,"Expression");
    definition=ExtraitRubrique(QString::fromUtf8("==== {{S|dérivés}} ===="),definition,&m_expression,"Dérivés");
    definition=ExtraitRubrique("==== {{S|proverbe}} ====",definition,&m_expression,"Proverbe");

    


        // '' => italique

        //suppression de (source|
    //definition.replace("(source|","(");
        // remplacement de (w|machin) par machin
    //definition.replace(QRegExp("\\(w\\|([^)]+)\\)"),"\\1");
    //definition.replace("\n:","\n");

        // mise en HTML


    definition=MakeTitle(definition);
    definition.replace(QRegExp("\\{\\{voir[^}]+\\}\\}"),"");



    definition.replace(QRegExp("\\{\\{fr-[^|]+\\|[^}]+\\}\\}"),"");
    definition.replace(QRegExp("\\{\\{pron\\|[^}]+\\}\\}"),"");
    definition.replace(QRegExp("\\(-*flex-"),"(");
    definition.replace(QRegExp("\\(-*verb-"),"(-Verbe-");
    definition.replace("(-Verbe-pr-)","(-Verbe pronominal-)");
    definition.replace(QRegExp("\\(-*[nN]om-pr-"),"(-Nom propre-");
    definition.replace(QRegExp("\\(-*nom-"),"(-Nom-");
    definition.replace(QRegExp("\\(-*prénom-"),"(-Prénom-");
    definition.replace(QRegExp("\\(-*adv-"),"(-Adverbe-");
    definition.replace(QRegExp("\\(-*adj-"),"(-Adjectif-");
    definition.replace("(-var-ortho-)","<span Style=\"Font: 18px Verdana; font-weight:bold; color:gray;padding:18px;\">Variante orthographique:</span>");

    definition=WikipediaFormate(definition);

    // remplacement des {{ par des (
    definition.replace("{{","(");
    // remplacement des }} par des }
    definition.replace("}}",")");
    // remplacement de (machin|fr) par [machin]
    definition.replace(QRegExp("\\(([^|)]+)\\|fr\\)"),"[\\1]");
    definition.replace("|"," - ");




    ///definition.replace("|nocat=1)",")");

    ///definition.replace("(-note-)","<span Style=\"Font: 18px Verdana; font-weight:bold; color:gray;padding:18px;\">Note:</span>");
    ///definition.replace("(-gent-)","<span Style=\"Font: 18px Verdana; font-weight:bold; color:gray;padding:18px;\">Habitants:</span>");

    ///
    ///definition.replace(QRegExp("\\(([^|]+)\\|fr\\)"),"(\\1)");


    // Mise en HTML
    definition.replace("Â°","&loz;");
    definition.replace("»","&raquo;");
    definition.replace("«","&laquo;");
    definition.replace("\n","<p>");
    if (ajout.endsWith(": "))   ajout="";
    definition="<html><body><i><b>"+ajout+"</b></i>"+definition+"</body></html>";
    // [[en:poule]] supprimé
    //$chaine=~s/\[\[[^:\]]+:pilosité\]\]//;
    ///QString ch="\\[\\[[^:\\]]+:"+mot+"\\]\\]";
    ///definition.replace(QRegExp(ch),"");

    definition.replace (".MERAL.",QString::fromUtf8("<i>Tiré du  Petit Dictionnaire des mots rares et anciens de la langue française  de Daniel Méral</i><p> "));
    ///definition.replace ("== (langue) ==","");

    return (definition);
}

QString formatage:: FormateExpression( QString definition)
{

   definition.replace(QRegExp (" +")," ");
   definition.replace(QRegExp ("^ +"),"");
   definition.replace(QRegExp ("^ "),"");
   definition=WikipediaFormate(definition);
   definition.replace("'","");
   definition.replace( "*","\n&bull;");
   definition.replace(":","\n&bull;");
   definition.replace("&bull;\n","\n");

   definition.replace("\n\n","\n");
   definition.replace("\n\n","\n");
   definition.replace("\n\n","\n");
   definition.replace("\n\n","\n");
   definition.replace(QRegExp ("^\n"),"\n");


   definition.replace("\n","<br>");
   definition.replace("|nocat=1","");
   definition="<html><body>"+definition;
   definition=definition+"</body></html>";
   return (definition);
}


QString formatage::CodePays(QString definition)
{
   if (definition == "af")  return QString::fromUtf8("africain");
   else if (definition == "la")  return QString::fromUtf8("latin");
   else if (definition == "fro")  return QString::fromUtf8("vieux français");
   else if (definition == "pro")  return QString::fromUtf8("provençal");
   else if (definition == "oc")  return QString::fromUtf8("occitan");
   else if (definition == "sq")  return QString::fromUtf8("albanais");
   else if (definition == "ar")  return QString::fromUtf8("arabe");
   else if (definition == "hy")  return QString::fromUtf8("arménien");
   else if (definition == "az")  return QString::fromUtf8("azerbajanais");
   else if (definition == "eu")  return QString::fromUtf8("basque");
   else if (definition == "be")  return QString::fromUtf8("biélarusse");
   else if (definition == "bn")  return QString::fromUtf8("bengali");
   else if (definition == "bs")  return QString::fromUtf8("bosniaque");
   else if (definition == "bg")  return QString::fromUtf8("bulgare");
   else if (definition == "ca")  return QString::fromUtf8("catalan");
   else if (definition == "ceb")  return QString::fromUtf8("cebuano");
   else if (definition == "zh-CN")  return QString::fromUtf8("chinois simplifié");
   else if (definition == "zh-TW")  return QString::fromUtf8("chinois traditionel");
   else if (definition == "hr")  return QString::fromUtf8("croate");
   else if (definition == "cs")  return QString::fromUtf8("tchec");
   else if (definition == "da")  return QString::fromUtf8("danois");
   else if (definition == "nl")  return QString::fromUtf8("néerlandais");
   else if (definition == "eo")  return QString::fromUtf8("esperanto");
   else if (definition == "et")  return QString::fromUtf8("estonien");
   else if (definition == "tl")  return QString::fromUtf8("philipin");
   else if (definition == "fi")  return QString::fromUtf8("finlandais");
   else if (definition == "fr")  return QString::fromUtf8("français");
   else if (definition == "gl")  return QString::fromUtf8("galicien");
   else if (definition == "ge")  return QString::fromUtf8("géorgien");
   else if (definition == "de")  return QString::fromUtf8("allemand");
   else if (definition == "grc")  return QString::fromUtf8("grec");
   else if (definition == "el")  return QString::fromUtf8("grec");
   else if (definition == "gu")  return QString::fromUtf8("gujati");
   else if (definition == "ht")  return QString::fromUtf8("créole haïtien");
   else if (definition == "ha")  return QString::fromUtf8("hausa");
   else if (definition == "iw")  return QString::fromUtf8("hébreu");
   else if (definition == "hi")  return QString::fromUtf8("hindi");
   else if (definition == "hmn")  return QString::fromUtf8("hmong");
   else if (definition == "hu")  return QString::fromUtf8("hongrois");
   else if (definition == "is")  return QString::fromUtf8("islandais");
   else if (definition == "ig")  return QString::fromUtf8("igbo");
   else if (definition == "id")  return QString::fromUtf8("indonésien");
   else if (definition == "ga")  return QString::fromUtf8("irlandais");
   else if (definition == "it")  return QString::fromUtf8("italien");
   else if (definition == "ja")  return QString::fromUtf8("japonais");
   else if (definition == "jw")  return QString::fromUtf8("javanais");
   else if (definition == "kn")  return QString::fromUtf8("kannada");
   else if (definition == "lm")  return QString::fromUtf8("khmer");
   else if (definition == "ko")  return QString::fromUtf8("coréen");
   else if (definition == "lo")  return QString::fromUtf8("lao");
   else if (definition == "lv")  return QString::fromUtf8("letton");
   else if (definition == "lt")  return QString::fromUtf8("lituanien");
   else if (definition == "mk")  return QString::fromUtf8("macédonien");
   else if (definition == "ms")  return QString::fromUtf8("malais");
   else if (definition == "mt")  return QString::fromUtf8("maltais");
   else if (definition == "mi")  return QString::fromUtf8("maori");
   else if (definition == "mr")  return QString::fromUtf8("marathi");
   else if (definition == "mn")  return QString::fromUtf8("mongolien");
   else if (definition == "ne")  return QString::fromUtf8("népalais");
   else if (definition == "no")  return QString::fromUtf8("norvégien");
   else if (definition == "fa")  return QString::fromUtf8("perse");
   else if (definition == "pl")  return QString::fromUtf8("polonais");
   else if (definition == "pt")  return QString::fromUtf8("portugais");
   else if (definition == "pa")  return QString::fromUtf8("punjabi");
   else if (definition == "ro")  return QString::fromUtf8("roumain");
   else if (definition == "ru")  return QString::fromUtf8("russe");
   else if (definition == "sr")  return QString::fromUtf8("serbe");
   else if (definition == "sk")  return QString::fromUtf8("slovaque");
   else if (definition == "sl")  return QString::fromUtf8("slovène");
   else if (definition == "so")  return QString::fromUtf8("somalien");
   else if (definition == "es")  return QString::fromUtf8("espagnol");
   else if (definition == "sw")  return QString::fromUtf8("swahili");
   else if (definition == "sv")  return QString::fromUtf8("suédois");
   else if (definition == "ta")  return QString::fromUtf8("tamoul");
   else if (definition == "te")  return QString::fromUtf8("telugu");
   else if (definition == "th")  return QString::fromUtf8("thaï");
   else if (definition == "tr")  return QString::fromUtf8("turc");
   else if (definition == "uk")  return QString::fromUtf8("ukrainien");
   else if (definition == "ur")  return QString::fromUtf8("urdu");
   else if (definition == "vi")  return QString::fromUtf8("vietnamien");
   else if (definition == "cy")  return QString::fromUtf8("welsh");
   else if (definition == "yi")  return QString::fromUtf8("yiddish");
   else if (definition == "yoruba")  return QString::fromUtf8("yoruba");
   else if (definition == "zu")  return QString::fromUtf8("zoulou");
   return(definition);

}


QString formatage::FormateEtymologie (QString definition)
{
        //definition.replace (QRegExp("''+([^']+)''+"),"<i>\\1</i>");

        definition.replace ("&lt;","<");
        definition.replace ("&gt;",">");
        definition.replace("{{e}}","<SUP>ème</SUP>");
        definition.replace("\n:","\n");
        definition=WikipediaFormate(definition);
        definition.replace("*","");
        definition.replace("{{ébauche-étym|fr}}","");
        QRegExp siecle("\\{\\{siècle\\|([^}|]+)\\}\\}");
        while( definition.contains(siecle))definition.replace(siecle,"("+ siecle.cap(1)+"<SUP>ème</SUP>" +"  siècle)");
        QRegExp date("\\{\\{date\\|([^}]+)\\}\\}");
        while ( definition.contains(date)) definition.replace(date,"<i>("+date.cap(1)+")</i>");
        QRegExp langue("\\{\\{étyl\\|([^|]+)\\|[^|]*(\\|mot=)*([^|}]*)(\\|sens=)*([^|}]*)[^}]*\\}+");
        while ( definition.contains(langue)) definition.replace(langue,CodePays(langue.cap(1))+ " " + langue.cap(3) + " " + langue.cap(5));
         definition.replace(QRegExp("lang=[^ ]+"),"");

        definition="<html><body>"+definition;
        definition=definition+"</body></html>";
        definition.replace("compos","composé de " );
        definition.replace("{{","");
        definition.replace("}}","");
        definition.replace("compos|","composé de" );
        definition.replace("|"," ");
       return definition;
}

QStringList formatage::FormateListe ( QString definition)
{
    QStringList liste;
    definition.replace(QRegExp("[^[]+\\[\\[([^]]+)\\]\\]"),"[[\\1]]") ; //suppression desparasistes au début
    definition.replace(QRegExp("\\]\\][^[]+\n"),"]]");// suppression des fins qui
    definition.replace("]][[",",");
    definition.replace("[[","");
    definition.replace("]]","");
    definition.replace("\n","");
    liste=definition.split(',');
    QStringList nouvelleliste;
    foreach ( QString l, liste){ l.replace(QRegExp("\\([^)]+\\)"),"");nouvelleliste.append(l);}

    return ( nouvelleliste);
}

QString formatage::FormateCitation (QString mot, QString phrase, QString auteur, QString rubrique)
{
    phrase.replace(mot,"<b>"+mot+"</b>");
    auteur.replace(auteur,"<i>"+auteur+"</i>");
    if ( rubrique.length() != 0 ) {rubrique.replace(rubrique,"<p><i>("+rubrique+")</i>");}
    return ("<html><body>"+phrase+"<p><p>"+auteur+rubrique+"</body></html>");
}


QString formatage::UcFirst(QString sentence)
{
    QChar c=sentence.at(0).toUpper();
    sentence.replace(0,1,c);
    return sentence;
}


QString formatage::WikipediaFormate(QString chaine)
{
    QRegExp crochets("\\[\\[[^]]+\\|([^]]+)\\]\\]");
    while ( chaine.contains(crochets)) chaine.replace(crochets,crochets.cap(1));
    QRegExp source("\\{\\{w\\|([^}]+)\\}\\}");
    while ( chaine.contains(source)) { chaine.replace(source,source.cap(1));}
    chaine.replace("[[","");
    chaine.replace("]]","");
    chaine.replace(QRegExp("'''([^']+)'''"),"<i><b>\\1</b></i>");
    chaine.replace(QRegExp("''([^']+)''"),"<i>\\1</i>");
    chaine.replace("''","");
    return chaine;
}

