#include "menutextbrowser.h"

MenuTextBrowser::MenuTextBrowser(QWidget *parent) :
    QTextBrowser(parent)
{
}
void MenuTextBrowser::contextMenuEvent(QContextMenuEvent *event)
{

    m_menu = createStandardContextMenu();
    m_cursor=this->cursorForPosition(event->pos());
    m_cursor.select(QTextCursor::WordUnderCursor);
    QString mot=m_cursor.selectedText();
    QAction *action1 = new QAction("Chercher les rimes avec «"+mot+"»",m_menu) ;
    QAction *action2 = new QAction(QString::fromUtf8("Chercher la définition de «")+mot+"»",m_menu) ;
    QAction *action3 = new QAction(QString::fromUtf8("Chercher des citations contenant  «")+mot+"»",m_menu) ;
    QAction *separateur = new QAction (m_menu);
    separateur->setSeparator(true);
    m_menu->insertAction(m_menu->actions().at(0),action1);
    m_menu->insertAction(m_menu->actions().at(1),action2);
    m_menu->insertAction(m_menu->actions().at(2),action3);
    m_menu->insertAction(m_menu->actions().at(3),separateur);
    connect ( m_menu,SIGNAL(triggered(QAction*)),this,SLOT(ActionMenu(QAction*)));
    m_menu->exec(event->globalPos());
}

void MenuTextBrowser::ActionMenu ( QAction *action)
{
    QString mot;
    QString Action ;
    QRegExp reg("«(.*)»");
    if ( action->text().contains(reg))
    {
        mot=reg.cap(1) ;
    }
    if ( action->text().contains("rimes") )
    {
     emit AskRime ( mot);
    }
    else if ( action->text().contains("définition"))
    {
        emit AskDefinition(mot);
    }
    else if ( action->text().contains("citation"))
    {
        emit AskCitation ( mot);
    }


}
