#include <QString>
#include <QStringList>
#include <QRegExp>
#include <QDebug>
#include "phonemise.h"

// Ce programme ne comprend pas de commentaire car il est une traduction du module perl phonemise.pm utilisé pour la fabrication des données
// Il est interdit de modifier des règles dans ce programme sans les modifier également dans le programme phonemise.pm


phonemise::phonemise ()
{
Exception["anus"]="sP";
Exception["cumulus"]="sP";
Exception["cubitus"]="sP";
Exception["tumulus"]="sP";
Exception["abribus"]="sP";
Exception["bus"]="sP";
Exception["phallus"]="sP";
Exception["uranus"]="sP";
Exception["cul"]="lM";
Exception["cucul"]="lM";
Exception["peignecul"]="lM";
Exception["culs"]="lM";
Exception["cuculs"]="lM";
Exception["peigneculs"]="lM";
debug=255;
}

void phonemise::SetDebug( int level)
{
  debug = level ;
}

void phonemise::UnsetDebug()
{
  debug = 255 ;
}

void phonemise::Debug ( int level , QString chaine )
{
 if ( debug <= level ) { qDebug()<<chaine; }
}


QString phonemise::TraiteA (QString mot)
{
Debug (9,"TraiteA : "+ mot);
mot.replace(QRegExp("ents$"),"@");
mot.replace(QRegExp("ends$"),"@");
mot.replace(QRegExp("aiement$"),"Em@");
mot.replace(QRegExp("faiss"),"feC");
mot.replace(QRegExp("faiz"),"f°z");
mot.replace(QRegExp("ail$"),"aJ");
mot.replace(QRegExp("aill"),"aJ");
mot.replace(QRegExp("âill"),"aJ");
mot.replace(QRegExp("aims*$"),"5");
mot.replace(QRegExp("tiaire"),"sJER");
mot.replace(QRegExp("man$"),"mAn");
mot.replace(QRegExp("atie"),"aCie");
mot.replace(QRegExp("ains*$"),"5");
mot.replace(QRegExp("ain([cdfgjkmqrstvwxz])"),"5\\1");
mot.replace(QRegExp("am([bp])"),"@\\1");
mot.replace(QRegExp("ans*$"),"@");
mot.replace(QRegExp("an([^naeiouyàèùéâêîôûäëïöüE§2598£@])"),"@\\1");
mot.replace(QRegExp("a(i|î)t$"),"E");
mot.replace(QRegExp("aient$"),"E");
mot.replace(QRegExp("airé"),"£R£");
mot.replace(QRegExp("aï"),"aJ");
mot.replace(QRegExp("a(i|î)"),"E");
mot.replace(QRegExp("â"),"a");
mot.replace(QRegExp("à"),"a");
mot.replace(QRegExp("ä"),"a");
mot.replace(QRegExp("eaux$"),"o");
mot.replace(QRegExp("aux$"),"o");
mot.replace(QRegExp("eau"),"o");
mot.replace(QRegExp("au"),"o");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteB (QString mot)
{
Debug (9,"TraiteB : "+ mot);
mot.replace(QRegExp("^b$"),"b£");
mot.replace(QRegExp("§bs*$"),"§");
mot.replace(QRegExp("bapt"),"bat");
mot.replace(QRegExp("abs"),"aps");
mot.replace(QRegExp("obs"),"ops");
mot.replace(QRegExp("obt"),"opt");
mot.replace(QRegExp("ybst"),"ypst");
Debug(10,mot);
return(mot)	;
}

QString phonemise::TraiteC (QString mot)
{
Debug (9,"TraiteC : "+ mot);
mot.replace(QRegExp("^c$"),"C£");
mot.replace(QRegExp("eç"),"°s");
mot.replace(QRegExp("eci"),"°si");
mot.replace(QRegExp("ancs*$"),"@");
mot.replace(QRegExp("tabacs*$"),"taba");
mot.replace(QRegExp("ce"),"se");
mot.replace(QRegExp("ci"),"si");
mot.replace(QRegExp("cî"),"si");
mot.replace(QRegExp("cé"),"s£");
mot.replace(QRegExp("cè"),"sE");
mot.replace(QRegExp("cE"),"sE");
mot.replace(QRegExp("cê"),"sE");
mot.replace(QRegExp("cy"),"si");
mot.replace(QRegExp("tachy"),"taki");
mot.replace(QRegExp("tachéo"),"takeo");
mot.replace(QRegExp("orchestr"),"orkEstR");
mot.replace(QRegExp("archè"),"arSE");
mot.replace(QRegExp("archi"),"arSi");
mot.replace(QRegExp("chiro"),"kiRo");
mot.replace(QRegExp("chle"),"Sle");
mot.replace(QRegExp("chli"),"Sli");
mot.replace(QRegExp("choe"),"koe");
mot.replace(QRegExp("chol"),"kol");
mot.replace(QRegExp("ch([lrnt])"),"k\\1");
mot.replace(QRegExp("ycho"),"iko");
mot.replace(QRegExp("arche"),"arS°");
mot.replace(QRegExp("cch"),"k");
mot.replace(QRegExp("écho"),"£ko");
mot.replace(QRegExp("atch"),"atS");
mot.replace(QRegExp("tch$"),"tS");
mot.replace(QRegExp("arch"),"ark");
mot.replace(QRegExp("acc([ieéèE5])"),"aks\\1");
mot.replace(QRegExp("chr"),"kR");
mot.replace(QRegExp("ch$"),"k");
mot.replace(QRegExp("ch"),"S");
mot.replace(QRegExp("cueill"),"k9J");
mot.replace(QRegExp("cueil"),"k9J");
mot.replace(QRegExp("c"),"k");
mot.replace(QRegExp("ç"),"s");
Debug(10,mot);
return(mot);
 }

QString phonemise::TraiteD (QString mot)
{
Debug (9,"TraiteD : "+ mot);
mot.replace(QRegExp("^d$"),"d£");
mot.replace(QRegExp("@d$"),"@");
mot.replace(QRegExp("od$"),"o");
mot.replace(QRegExp("ed$"),"Ed");
mot.replace(QRegExp("rds*$"),"R");
mot.replace(QRegExp("Wad$"),"Wa");
Debug(10,mot);
return(mot);
 }


QString phonemise::TraiteE (QString mot)
{
Debug (9,"TraiteE : "+ mot);
mot.replace(QRegExp("^([bsdfZklmnprtvz])e$"),"\\12");
mot.replace(QRegExp("^é$"),"£");
mot.replace(QRegExp("grée"),"gR£");
mot.replace(QRegExp("ea"),"i");
mot.replace(QRegExp("ets*$"),"£");
mot.replace(QRegExp("êts*$"),"E");
mot.replace(QRegExp("ements*$"),"em@");
mot.replace(QRegExp("ee"),"i");
mot.replace(QRegExp("([^8t])e$"),"\\1");
mot.replace(QRegExp("eR$"),"£");
mot.replace(QRegExp("ients*$"),"J@");
mot.replace(QRegExp("ientes*$"),"J@t");
mot.replace(QRegExp("ienc"),"J@s");
mot.replace(QRegExp("ienc"),"J@s");
mot.replace(QRegExp("ien([^n]*)"),"J5");
mot.replace(QRegExp("^(.)ent$"),"\\1@");
mot.replace(QRegExp("([^m])ent$"),"\\1");
mot.replace(QRegExp("en([^naeiouyàèùéâêîôûäëïöüUE§2598£@JWo])"),"@\\1");
mot.replace(QRegExp("em([pb])"),"@\\1");
mot.replace(QRegExp("@t$"),"@");
mot.replace(QRegExp("ez$"),"£");
mot.replace(QRegExp("eR([aeio§Eo])"),"R\\1");
mot.replace(QRegExp("ê"),"E");
mot.replace(QRegExp("è"),"E");
mot.replace(QRegExp("es$"),"e");
mot.replace(QRegExp("esc"),"es");
mot.replace(QRegExp("es"),"Es");
mot.replace(QRegExp("ems*$"),"Em");
mot.replace(QRegExp("egs*$"),"Eg");
mot.replace(QRegExp("eR([bcdgklmnrstvZSTNGCµ])"),"ER\\1");
mot.replace(QRegExp("ek([aou])"),"°k\\1");
mot.replace(QRegExp("ek"),"Ek");
mot.replace(QRegExp("ep"),"Ep");
mot.replace(QRegExp("el$"),"El");
mot.replace(QRegExp("ef$"),"Ef");
mot.replace(QRegExp("enn"),"En");
mot.replace(QRegExp("ec"),"Ec");
mot.replace(QRegExp("é$"),"£");
mot.replace(QRegExp("é"),"£");
mot.replace(QRegExp("te$"),"t");
mot.replace(QRegExp("ie$"),"Je");
mot.replace(QRegExp("i2"),"J2");
mot.replace(QRegExp("i§"),"J§");
mot.replace(QRegExp("iE"),"JE");
mot.replace(QRegExp("ReR([oa])s*"),"R£R\\1");
mot.replace(QRegExp("^ben"),"b°n");
mot.replace(QRegExp("^Zen"),"Z°n");
mot.replace(QRegExp("^den"),"d°n");
mot.replace(QRegExp("vet"),"v°t");
mot.replace(QRegExp("zem"),"z°m");
mot.replace(QRegExp("([bsdfgZklmnpRtvxzS])e([bsdfgZklmnpRtvxzS])([bsdfgZklmnpRtvxzS])"),"\\1E\\2\\3");
mot.replace(QRegExp("([bsdfgZklmnpRtvxzS])e([bsdfgZklmnpRtvxzS])"),"\\1°\\2");
mot.replace(QRegExp("kRem"),"kR£m");
mot.replace(QRegExp("([nsSrgJlfzRkt])em"),"\\1m");
mot.replace(QRegExp("([v])em"),"\\1°m");
Debug(10,mot);
return(mot);
 }

QString phonemise::TraiteF (QString mot)
{
Debug (9,"TraiteF : "+ mot);
mot.replace(QRegExp("^f$"),"Ef");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteG (QString mot)
{
Debug (9,"TraiteG : "+ mot);
mot.replace(QRegExp("^g$"),"Z£");
mot.replace(QRegExp("gnos(.*)"),"Gnos\\1");
mot.replace(QRegExp("gnom(.*)"),"Gnom\\1");
mot.replace(QRegExp("gn"),"NJ");
mot.replace(QRegExp("geuze"),"Z2z");
mot.replace(QRegExp("geu"),"Z9");
mot.replace(QRegExp("ge([âaoE§@])"),"Z\\1");
mot.replace(QRegExp("g([eiyèéâêîëïE259])"),"Z\\1");
mot.replace(QRegExp("guï"),"G8i");
mot.replace(QRegExp("guë"),"GY");
mot.replace(QRegExp("gent"),"Z@");
mot.replace(QRegExp("g@"),"Z@");
mot.replace(QRegExp("gu([aeiouyàèùéâêîôûäöüE§2598£@])"),"G\\1");
mot.replace(QRegExp("gt"),"t");
Debug(10,mot);
return(mot);
 }

QString phonemise::TraiteH  (QString mot)
{
Debug (9,"TraiteH : "+ mot);
mot.replace(QRegExp("^h$"),"aS");
mot.replace(QRegExp("th$"),"te");
mot.replace(QRegExp("ph"),"f");
mot.replace(QRegExp("h"),"");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteI (QString mot)
{
Debug (9,"TraiteI : "+ mot);
mot.replace(QRegExp("ain([^aeiouy])"),"5\\1");
mot.replace(QRegExp("ains$"),"5");
mot.replace(QRegExp("ain$"),"5");
mot.replace(QRegExp("ein([aeiouyàèùéâêîôûäëïöüEo§2598£@])"),"En\\1");
mot.replace(QRegExp("ein([^aeiouyàèùéâêîôûäëïöüEo§2598£@])"),"5\\1");
mot.replace(QRegExp("eint*s*"),"5");
mot.replace(QRegExp("ings*$"),"iQ");
mot.replace(QRegExp("in([^aeiouyàèùéâêîôûäëïöüEo§2598n£@W])"),"5\\1");
mot.replace(QRegExp("în([^aeiouyàèùéâêîôûäëïöüEo§2598n£@W])"),"5\\1");
mot.replace(QRegExp("in$"),"5");
mot.replace(QRegExp("im([pb])"),"5\\1");
mot.replace(QRegExp("ieds*$"),"i£");
mot.replace(QRegExp("ie$"),"i");
mot.replace(QRegExp("([bcdfgkptv])ri([eao§@5E])"),"\\1riJ\\2");
mot.replace(QRegExp("ienn"),"JEn");
mot.replace(QRegExp("ients*$"),"J@");
mot.replace(QRegExp("ientes*$"),"J@µ");
mot.replace(QRegExp("ienc"),"J@s");
mot.replace(QRegExp("ien"),"J5");
mot.replace(QRegExp("iens*$"),"J5");
mot.replace(QRegExp("siennes*$"),"zJEn");
mot.replace(QRegExp("iennes*$"),"JEn");
mot.replace(QRegExp("éens*$"),"e5");
mot.replace(QRegExp("([^gZf])ill"),"\\1iJ");
mot.replace(QRegExp("iera$"),"iRa");
mot.replace(QRegExp("ierE$"),"iRE");
mot.replace(QRegExp("ier§$"),"iR§");
mot.replace(QRegExp("ierait*s*$"),"iRE");
mot.replace(QRegExp("ieront*s*$"),"iRon");
mot.replace(QRegExp("ierez$"),"iRE");
mot.replace(QRegExp("eil+"),"EJ");
mot.replace(QRegExp("ei"),"E");
mot.replace(QRegExp("tiel+"),"sJEl");
mot.replace(QRegExp("([bcdfgkpt])rio"),"\\1RiJo");
mot.replace(QRegExp("i([aeiouyàèùéâêîôûäëïöüEo§2598£@])"),"J\\1");
mot.replace(QRegExp("î"),"i");
mot.replace(QRegExp("six$"),"siC");
mot.replace(QRegExp("^dix$"),"diC");
mot.replace(QRegExp("ix$"),"i");
mot.replace(QRegExp("([Rrs])i([aeo])"),"\\1sJ\\2");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteJ (QString mot)
{
Debug (9,"TraiteJ : "+ mot);
mot.replace(QRegExp("^j$"),"Zi");
mot.replace(QRegExp("jean"),"Zan");
mot.replace(QRegExp("ej"),"°Z");
mot.replace(QRegExp("j"),"Z");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteK (QString mot)
{
Debug (9,"TraiteK : "+ mot);
mot.replace(QRegExp("^k$"),"ka");
mot.replace(QRegExp("oker$"),"okER");
mot.replace(QRegExp("c*ker$"),"k9R");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteL  (QString mot)
{
Debug (9,"TraiteL : "+ mot);
mot.replace(QRegExp("^l$"),"El") ;
mot.replace(QRegExp("gilles"),"Zil") ;
mot.replace(QRegExp("ieil"),"JEJ");
mot.replace(QRegExp("ueill"),"9J");
mot.replace(QRegExp("ieill"),"JEJ");
mot.replace(QRegExp("eill"),"EJ");
mot.replace(QRegExp("ueil"),"9J");
mot.replace(QRegExp("eil"),"EJ");
mot.replace(QRegExp("([aou])ille"),"\\1J");
mot.replace(QRegExp("([aou])il"),"\\1J");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteM  (QString mot)
{
Debug (9,"TraiteM : "+ mot);
mot.replace(QRegExp("^m$"),"Em") ;
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteN  (QString mot)
{
Debug (9,"TraiteN : "+ mot);
mot.replace(QRegExp("^n$"),"En") ;
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteO (QString mot)
{
Debug (9,"TraiteO : "+ mot);
mot.replace(QRegExp("ow"),"o");
mot.replace(QRegExp("oots*$"),"ut");
mot.replace(QRegExp("([oo])ts*$"),"\\1");
mot.replace(QRegExp("ond*t*s*$"),"§");
mot.replace(QRegExp("kompt"),"k§t");
mot.replace(QRegExp("ons*$"),"§");
mot.replace(QRegExp("ont$"),"§");
mot.replace(QRegExp("omt"),"§t");
mot.replace(QRegExp("oin([^aeiouynéEè@285§o])"),"W5\\1");
mot.replace(QRegExp("oin$"),"W5");
mot.replace(QRegExp("ion([^aeiouynéEè@285§o])"),"J§\\1");
mot.replace(QRegExp("on([^aeiouynéEè@285§o])"),"§\\1");
mot.replace(QRegExp("oiement$"),"wam@");
mot.replace(QRegExp("oiem@$"),"wam@");
mot.replace(QRegExp("om([bp])"),"§\\1");
mot.replace(QRegExp("ons*$"),"§");
mot.replace(QRegExp("oix$"),"Wa");
mot.replace(QRegExp("oi"),"Wa");
mot.replace(QRegExp("oî"),"Wa");
mot.replace(QRegExp("^oe"),"2");
mot.replace(QRegExp("oeu"),"9");
mot.replace(QRegExp("zoom"),"zum");
mot.replace(QRegExp("zoo"),"zoo");
mot.replace(QRegExp("koop"),"kop");
mot.replace(QRegExp("koord"),"koord");
mot.replace(QRegExp("alkool"),"alkol");
mot.replace(QRegExp("oo"),"U");
mot.replace(QRegExp("oeil+"),"9J");
mot.replace(QRegExp("oïn"),"o5");
mot.replace(QRegExp("O"),"o");
mot.replace(QRegExp("ô"),"o");
Debug(10,"Traite o"+mot);
return(mot);
}

QString phonemise::TraiteP  (QString mot)
{
Debug (9,"TraiteP : "+ mot);
mot.replace(QRegExp("^p$"),"p£") ;
mot.replace(QRegExp("skylpt"),"skylt") ;
Debug(10,mot);
return(mot);
}


QString phonemise::TraiteQ (QString mot)
{
Debug (9,"TraiteQ : "+ mot);
mot.replace(QRegExp("^q$"),"qY") ;
mot.replace(QRegExp("q$"),"k");
mot.replace(QRegExp("^aqua"),"akwa");
mot.replace(QRegExp("qu"),"k");
mot.replace(QRegExp("qû"),"kY");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteR (QString mot)
{
Debug (9,"TraiteR : "+ mot);
mot.replace(QRegExp("^r$"),"ER") ;
mot.replace(QRegExp("^(.)er$"),"\\1ER") ;
mot.replace(QRegExp("^rept"),"REpt");
mot.replace(QRegExp("^rekt"),"REct");
mot.replace(QRegExp("^rest"),"REst");
mot.replace(QRegExp("^ren([cdfgjklqrstvxz])"),"R@\\1");
mot.replace(QRegExp("^rem([bp])"),"R@\\1");
mot.replace(QRegExp("^re"),"R°");
mot.replace(QRegExp("ert$"),"%");
mot.replace(QRegExp("ers$"),"%");
mot.replace(QRegExp("er([bcdfgjklmnpqrstv])"),"ER\\1");
mot.replace(QRegExp("r"),"R");
mot.replace(QRegExp("RR"),"R");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteS (QString mot)
{
Debug (9,"TraiteS : "+ mot);
mot.replace(QRegExp("^s$"),"EC") ;
mot.replace(QRegExp("ess$"),"EC") ;
mot.replace(QRegExp("esç"),"eC") ;
mot.replace(QRegExp("susu"),"CYCY") ;
mot.replace(QRegExp("^as([oy])"),"as\\1");
mot.replace(QRegExp("([aeiouyàèùéâêîôûäëïöüE§2598£])s([aeiouyàèùéâêîôûäëïöüE§2598£])"),"\\1z\\2");
mot.replace(QRegExp("ansi([st]*)"),"@zi\\1");
mot.replace(QRegExp("lsant"),"ls@");
mot.replace(QRegExp("lsa"),"lza");
mot.replace(QRegExp("isme$"),"izm");
mot.replace(QRegExp("^([cdlmst])es$"),"\\1£");
mot.replace(QRegExp("([aeio])s$"),"\\1");
mot.replace(QRegExp("(i|ï)sme"),"izm");
mot.replace(QRegExp("ents$"),"@");
mot.replace(QRegExp("sh"),"S");
mot.replace(QRegExp("pays$"),"peï");
mot.replace(QRegExp("s$"),"");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteT (QString mot)
{
Debug (9,"TraiteT : "+ mot);
mot.replace(QRegExp("^est$"),"£") ;
mot.replace(QRegExp("^t$"),"t£") ;
mot.replace(QRegExp("kRati"),"kRasi");
mot.replace(QRegExp("@t$"),"@");
mot.replace(QRegExp("tière"),"tiER");
mot.replace(QRegExp("étJEne"),"eTEne");
mot.replace(QRegExp("étJ5s*"),"eT5");
mot.replace(QRegExp("(.+)stJEne"),"\\1sTEne");
mot.replace(QRegExp("(.+)tJEne"),"\\1sJEne");
mot.replace(QRegExp("(.+)tJ5s*$"),"\\1sJ5");
mot.replace(QRegExp("5t$"),"5");
mot.replace(QRegExp("([Rr])t$"),"\\1");
mot.replace(QRegExp("[oo]t$"),"o");
mot.replace(QRegExp("éth*io"),"eTo");
mot.replace(QRegExp("ttJ"),"TJ");
mot.replace(QRegExp("£tJ§$"),"£T§");
mot.replace(QRegExp("stJ"),"sT");
mot.replace(QRegExp("stJ§"),"sT§");
mot.replace(QRegExp("tJ§"),"sJ§");
mot.replace(QRegExp("ti§"),"sJ§");
mot.replace(QRegExp("ti([aoo])"),"sJ\\1");
mot.replace(QRegExp("tJ([aoo])"),"sJ\\1");
mot.replace(QRegExp("tiez$"),"tJe");
mot.replace(QRegExp("tie([^sz]+)"),"sie\\1");
mot.replace(QRegExp("@ts*$"),"@");
mot.replace(QRegExp("§t$"),"§");
mot.replace(QRegExp("it$"),"i");
mot.replace(QRegExp("at$"),"a");
Debug(10,mot);
return(mot);
}


QString phonemise::TraiteU (QString mot)
{
Debug (9,"TraiteU: "+ mot);
mot.replace(QRegExp("ût$"),"u");
mot.replace(QRegExp("ut$"),"u");
mot.replace(QRegExp("amus$"),"amuC");
mot.replace(QRegExp("anus$"),"anuC");
mot.replace(QRegExp("aurus$"),"auruC");
mot.replace(QRegExp("û"),"u");
mot.replace(QRegExp("œil"),"9J");
mot.replace(QRegExp("œu([rfv])"),"9\\1");
mot.replace(QRegExp("œud*$"),"2");
//mot.replace(QRegExp("œ*$"),"°");
mot.replace(QRegExp("oeu"),"9");
mot.replace(QRegExp("euill"),"9J");
mot.replace(QRegExp("euil"),"9J");
mot.replace(QRegExp("([bcdfgpstv])rieur"),"\\1riJ9R");
mot.replace(QRegExp("rieur"),"rJ9R");
mot.replace(QRegExp("neur$"),"n9R");
mot.replace(QRegExp("neur"),"n2R");
mot.replace(QRegExp("eur"),"9R");
mot.replace(QRegExp("euze"),"2z");
mot.replace(QRegExp("eul"),"9l");
mot.replace(QRegExp("euv"),"9v");
mot.replace(QRegExp("euf"),"9f");
mot.replace(QRegExp("eut$"),"2");
mot.replace(QRegExp("eut"),"2t");
mot.replace(QRegExp("eux$"),"2");
mot.replace(QRegExp("eu"),"2");
mot.replace(QRegExp("ouel"),"uEl");
mot.replace(QRegExp("uel"),"8El");
mot.replace(QRegExp("([bcdfhjklmnprstvzw])uer$"),"\\18£");
mot.replace(QRegExp("([bcdfhjklmnprstvzw])uée*s*$"),"\\18£");
mot.replace(QRegExp("([bcdfhjklmnprstvzw])ueras*$"),"\\1YRa");
mot.replace(QRegExp("([bcdfhjklmnprstvzw])uerai*s*t*$"),"\\1YR£");
mot.replace(QRegExp("([bcdfhjklmnprstvzw])uais*t*$"),"\\18E");
mot.replace(QRegExp("([bcdfhjklmnprstvzw])uaient$"),"\\18E");
mot.replace(QRegExp("([bcdfhjklmnprstvzw])uE$"),"\\18E");
mot.replace(QRegExp("([bcdfhjklmnprstvzw])ua+s*t*$"),"\\18a");
mot.replace(QRegExp("ru@"),"rU@");
mot.replace(QRegExp("([bcdfhjklmnprstvzw])u([é@aèoiy29])"),"\\18\\2");
mot.replace(QRegExp("um$"),"om");
mot.replace(QRegExp("oua"),"Wa");
mot.replace(QRegExp("ua"),"8a");
mot.replace(QRegExp("e*un([^aeiouyàèùéâêîôûäëïöüE§2598£])"),"1\\1");
mot.replace(QRegExp("([^oe])u"),"\\1y");
mot.replace(QRegExp("rouet$"),"RU£");
mot.replace(QRegExp("roué"),"RU£");
mot.replace(QRegExp("oué"),"W£");
mot.replace(QRegExp("oua"),"Wa");
mot.replace(QRegExp("ouill"),"UJ");
mot.replace(QRegExp("loui"),"lUi");
mot.replace(QRegExp("oui"),"Wi");
mot.replace(QRegExp("out$"),"U");
mot.replace(QRegExp("oup$"),"U");
mot.replace(QRegExp("iou"),"JU");
mot.replace(QRegExp("kaoutSouks*"),"kaUtSU");
mot.replace(QRegExp("kaout"),"kaUt");
mot.replace(QRegExp("aou"),"U");
mot.replace(QRegExp("ou"),"U");
mot.replace(QRegExp("ôu"),"U");
mot.replace(QRegExp("oû"),"U");
mot.replace(QRegExp("uy"),"8iJ");
mot.replace(QRegExp("e*unt*s*$"),"1");
mot.replace(QRegExp("u"),"Y");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteV (QString mot)
{
Debug (9,"TraiteV : "+ mot);
mot.replace(QRegExp("^v$"),"v£");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteW (QString mot)
{
Debug (9,"TraiteW : "+ mot);
mot.replace(QRegExp("^w$"),"dyblv£");
mot.replace(QRegExp("wa"),"va");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteX (QString mot)
{
Debug (9,"TraiteX : "+ mot);
mot.replace(QRegExp("^x$"),"iks");
mot.replace(QRegExp("2x$"),"2");
mot.replace(QRegExp("Ux$"),"U");
mot.replace(QRegExp("wax$"),"wa");
mot.replace(QRegExp("x$"),"ks");
mot.replace(QRegExp("^exi"),"Egzi"),
mot.replace(QRegExp("^exe"),"Egze"),
mot.replace(QRegExp("^exE"),"Egze"),
mot.replace(QRegExp("^exa"),"Egza"),
mot.replace(QRegExp("exsi"),"EkCi");
mot.replace(QRegExp("exi"),"EkCi");
mot.replace(QRegExp("exes*$"),"Eks");
mot.replace(QRegExp("exeR$"),"Ekse");
mot.replace(QRegExp("exeR(.*)$"),"EkseR\\1");
mot.replace(QRegExp("ax"),"aks");
mot.replace(QRegExp("ixJèm"),"izjEm");
mot.replace(QRegExp("ixi"),"iksi");
mot.replace(QRegExp("^x([aoieéo£])"),"gz\\1");
mot.replace(QRegExp("ex([aoieéo£])"),"Egz\\1");
mot.replace(QRegExp("ex"),"Eks");
mot.replace(QRegExp("yx"),"iks");
mot.replace(QRegExp("ix"),"iks");
mot.replace(QRegExp("x([cèEi])"),"ks\\1");
mot.replace(QRegExp("x"),"gz");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteY (QString mot)
{
Debug (9,"TraiteY : "+ mot);
mot.replace(QRegExp("^y$"),"igrEk");
mot.replace(QRegExp("yll"),"il");
mot.replace(QRegExp("e*uns*$"),"1");
mot.replace(QRegExp("ays"),"eïs");
mot.replace(QRegExp("ryo"),"riJo");
mot.replace(QRegExp("oyou"),"WaJU");
mot.replace(QRegExp("you"),"JU");
mot.replace(QRegExp("yens*$"),"y5");
mot.replace(QRegExp("boy"),"boJ");
mot.replace(QRegExp("oy([aeéè@§5uooU]|ou)"),"WaJ\\1");
mot.replace(QRegExp("oy([aeéè@§5uooqU]|ou)"),"WaJ\\1");
mot.replace(QRegExp("yeu"),"J2");
mot.replace(QRegExp("ay([aâéèe2J])"),"EJ\\1");
mot.replace(QRegExp("ay([aeéè@§5uoo])"),"eJ\\1");
mot.replace(QRegExp("uy"),"8iJ");
mot.replace(QRegExp("ey"),"EJ");
mot.replace(QRegExp("y([^aeqiouy8925])"),"i\\1");
mot.replace(QRegExp("yx"),"iks");
mot.replace(QRegExp("y"),"i");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteZ (QString mot)
{
Debug (9,"TraiteZ : "+ mot);
mot.replace(QRegExp("^z$"),"zEd");
mot.replace(QRegExp("tz"),"ts");
Debug(10,mot);return(mot);
}


QString phonemise::FinMuette (QString mot)
{
Debug (9,"Fin Muette : "+ mot);
mot.replace(QRegExp("lt$"),"");
mot.replace(QRegExp("pects*$"),"p£");
mot.replace(QRegExp("([lp])pects*$"),"\\1£");
mot.replace(QRegExp("tacts*$"),"takt");
mot.replace(QRegExp("ends*$"),"@");
mot.replace(QRegExp("champs*$"),"S@");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteTrema (QString mot)
{
Debug (9,"Taitre trema : "+ mot);
mot.replace(QRegExp("ä"),"a");
mot.replace(QRegExp("ë"),"e");
mot.replace(QRegExp("ï"),"i");
mot.replace(QRegExp("ö"),"o");
mot.replace(QRegExp("ü"),"o");
mot.replace(QRegExp("ÿ"),"y");
Debug(10,mot);
return(mot);
}

QString phonemise::ChangeLettresFictives (QString mot)
{
Debug (9,"Change lettres fictives : "+ mot);
mot.replace(QRegExp("A"),"a");
mot.replace(QRegExp("£"),"e");
mot.replace(QRegExp("J"),"j");
mot.replace(QRegExp("N"),"n");
mot.replace(QRegExp("T"),"tj");
mot.replace(QRegExp("W"),"w");
mot.replace(QRegExp("C"),"s");
mot.replace(QRegExp("G"),"g");
mot.replace(QRegExp("Q"),"G");
mot.replace(QRegExp("Y"),"y");
mot.replace(QRegExp("U"),"u");
mot.replace(QRegExp("%"),"eR");
mot.replace(QRegExp("µ"),"t");
Debug(10,mot);
return(mot);
}

QString phonemise::TraiteDoubleConsonne (QString mot)
{
Debug (9,"Traite Double Consonne : "+ mot);
mot.replace(QRegExp("emment"),"am@");
mot.replace(QRegExp("emm"),"@m");
mot.replace(QRegExp("enn"),"En");
mot.replace(QRegExp("ess9"),"£ss9");
mot.replace(QRegExp("ellé"),"£l£");
mot.replace(QRegExp("ell"),"El");
mot.replace(QRegExp("jazz"),"dSaz");
mot.replace(QRegExp("([aiou])zz"),"\\1dz");
mot.replace(QRegExp("ezz"),"£dz");
mot.replace(QRegExp("ttJ"),"T");
mot.replace(QRegExp("e([cdfgjlprstz])\\1e"),"E\\1e");
mot.replace(QRegExp("e([cdfgjlprstz])\\1"),"£\\1");
mot.replace(QRegExp("([^bdfgklmnpruZ])ill"),"iJ");
mot.replace(QRegExp("([bdfgjklmnprstvwx])\\1"),"\\1");
Debug(10,mot);
return(mot);
}





QString phonemise::SupprimePonctuation  (QString mot)
{
mot.replace(QRegExp("[',;:\"]"),"");
Debug(9,"Supprime ponctuation" + mot);
return(mot);
}

QString phonemise::Exceptions  (QString mot)
{
 if ( Exception[mot] == "sP" ) { mot.replace(QRegExp("s$"),"C") ; }
 else if ( Exception[mot] == "lM" ) {mot.replace(QRegExp("l$"),"") ; }
 else if (mot.indexOf(QRegExp("^culs*s$")) >= 0) { mot="ky";}
 else if (mot.indexOf(QRegExp("^cuculs*$")) >= 0) { mot="kyky";}
 Debug(9,"Fin Exceptions : "+ mot);
return(mot);
}

QString phonemise::Sigle  (QString mot)
{
 QString retour="" ;
 mot.replace(".","");
 Debug(9,"Entrée Sigle :"+mot);
 if ( mot.indexOf(QRegExp("^[A-Z]+$"))>=0)
  {
   mot=Minuscule(mot);
   QStringList lettres = mot.split("");
   for (int i = 0; i < lettres.size(); ++i) {
	 Debug(12,"lettres dans sigles"+lettres.at(i));
	 retour+=PhonemiseMot(lettres.at(i)); }
  }
Debug (9,"Sigle : "+retour);
return(retour);
}

QString phonemise::PhonemiseAvecRacine  (QString mot)
{


 QRegExp ExpAfters("afters*(.*)");
 QRegExp ExpAnti("^anti(.*)");
 QRegExp ExpAuto("^auto(.*)");
 QRegExp ExpBacilles("(.*)bacilles*(.*)");
 QRegExp ExpBluff("(.*)bluff(.*)");
 QRegExp ExpCamps("(.*)camps$");
 QRegExp ExpChore("^choré(.*)");
 QRegExp ExpClub("(.*)club(.*)");
 QRegExp ExpCodicille("(.*)codicille(.*)");
 QRegExp ExpDessous("(.*)dessous(.*)");
 QRegExp ExpDessus("(.*)dessus(.*)");
 QRegExp ExpElectro("(.*)electro*(.*)");
 QRegExp ExpEndum("(.*)endum$");
 QRegExp ExpEqua("(.*)équa([^n]+)");
 QRegExp ExpFascismes("(.*)fascismes(.*)");
 QRegExp ExpFascistes("(.*)fascistes*(.*)");
 QRegExp ExpGentilhom("gentilhomm(.*)");
 QRegExp ExpGirl("(.*)girl(.*)");
 QRegExp ExpGirls("(.*)girls*$");
 QRegExp ExpGround( "(.*)ground-*(.*)");
 QRegExp ExpMessieurs("(.*)messieurs(.*)");
 QRegExp ExpMonsieur("(.*)monsieur(.*)");
 QRegExp ExpQuadr("(.*)quadr(.*)");
 QRegExp ExpMille("(.*)mille(.*)");
 QRegExp ExpNoms("(.*)noms*$");
 QRegExp ExpOrient("(.*)orient(.*)");
 QRegExp ExpPoids("(.*)poids$");
 QRegExp ExpSaint("saint-([aeiouyhàâéèêîöû])(.*)");
 QRegExp ExpSecond("(.*)second(.*)");
 QRegExp ExpSeconds("(.*)seconds*$");
 QRegExp ExpSous("sous-([aeiouyhàâéèêîöû])(.*)");
 QRegExp ExpSuspense("(.*)suspense$");
 QRegExp ExpSupers("(.*)supers*");
 QRegExp ExpTechn("(.*)techn(.*)");
 QRegExp ExpTele("télé(.*)");
 QRegExp ExpTier("^tiers-(.*)$");
 QRegExp ExpTiers("^tiers$");
 QRegExp ExpTrust("(.*)trust(.*)");
 QRegExp ExpTranquilles("(.*)tranquilles*(.*)");
 QRegExp ExpTranquill("(.*)tranquill*(.*)");
 QRegExp ExpTranquillo("(.*)tranquillo(.*)");
 QRegExp ExpTranquillou("(.*)tranquillou(.*)");
 QRegExp ExpUltra("(.*)ultra(.*)");
 QRegExp ExpUnder("(.*)under(.*)");
 QRegExp ExpVille("^ville*([^e].*)");
 QRegExp ExpVilles("(.*)ville$");
 QRegExp ExpVert("(.*)vert-(.*)");
 QRegExp ExpVingt("(.*)vingt(.*)");
 QRegExp ExpVraisembl("(.*)vraisembl(.*)");


 QString retour=Sigle(mot);
Debug(8,"PhonemiseAvecRacine  retour : "+retour);
 if (   retour!="" ) { mot=retour; }
 else {
 mot=Minuscule(mot);
//  mot = mot.toUtf8();
 if (ExpEqua.indexIn(mot) >=0 ) { mot=PhonemiseAvecRacine(ExpEqua.cap(1))+"ekwa"+PhonemiseAvecRacine(ExpEqua.cap(2)); }
 else if (ExpGround.indexIn(mot) >=0  ) { mot=PhonemiseAvecRacine(ExpGround.cap(1))+"gRawnd"+PhonemiseAvecRacine(ExpGround.cap(2)); }
 else if (ExpVert.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpVert.cap(1))+"vEr"+PhonemiseAvecRacine(ExpVert.cap(2)); }
 else if (ExpUnder.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpUnder.cap(1))+"9nd9R"+PhonemiseAvecRacine(ExpUnder.cap(2)); }
 else if (ExpUltra.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpUltra.cap(1))+"yltRa"+PhonemiseAvecRacine(ExpUltra.cap(2)); }
 else if (ExpVraisembl.indexIn(mot) >=0  ) { mot=PhonemiseAvecRacine(ExpVraisembl.cap(1))+"vREs@bl"+PhonemiseAvecRacine(ExpVraisembl.cap(2)); }
 else if (ExpGirl.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpGirl.cap(1))+"g9Rl"+PhonemiseAvecRacine(ExpGirl.cap(2)); }
 else if (ExpElectro.indexIn(mot) >=0  ) { mot=PhonemiseAvecRacine(ExpElectro.cap(1))+"elektRo"+PhonemiseAvecRacine(ExpElectro.cap(2)); }
 else if (ExpTrust.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpTrust.cap(1))+"tR9st"+PhonemiseAvecRacine(ExpTrust.cap(2)); }
 else if (ExpBluff.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpBluff.cap(1))+"bl9f"+PhonemiseAvecRacine(ExpBluff.cap(2)); }
 else if (ExpVingt.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpVingt.cap(1))+"v5t"+PhonemiseAvecRacine(ExpVingt.cap(2)); }
 else if (ExpTranquilles.indexIn(mot) >=0  ) { mot=PhonemiseAvecRacine(ExpTranquilles.cap(1))+"tR@kil"+PhonemiseAvecRacine(ExpTranquilles.cap(2));}
 else if (ExpTranquillou.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpTranquillou.cap(1))+"tR@kily"+PhonemiseAvecRacine(ExpTranquillou.cap(2)); }
 else if (ExpTranquillo.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpTranquillo.cap(1))+"tR@kilo"+PhonemiseAvecRacine(ExpTranquillo.cap(2)); }
 else if (ExpTranquill.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpTranquill.cap(1))+"tR@kil"+PhonemiseAvecRacine(ExpTranquill.cap(2)); }
 else if (ExpCodicille.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpCodicille.cap(1))+"kodisil"+PhonemiseAvecRacine(ExpCodicille.cap(2)); }
 else if (ExpQuadr.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpQuadr.cap(1))+"kwadR"+PhonemiseAvecRacine(ExpQuadr.cap(2)); }
 else if (ExpFascistes.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpFascistes.cap(1))+"faSist"; }
 else if (ExpFascismes.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpFascismes.cap(1))+"fascismes*"+PhonemiseAvecRacine(ExpFascismes.cap(2)); }
 else if (ExpBacilles.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpBacilles.cap(1))+"bacil"+PhonemiseAvecRacine(ExpBacilles.cap(2)); }
 else if (ExpMille.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpMille.cap(1))+"mil"+PhonemiseAvecRacine(ExpMille.cap(2)); }
 else if (ExpClub.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpClub.cap(1))+"kl9b"+PhonemiseAvecRacine(ExpClub.cap(2)); }
 else if (ExpSeconds.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpSeconds.cap(1))+"s°g§"+PhonemiseAvecRacine(ExpSeconds.cap(2)); }
 else if (ExpSecond.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpSecond.cap(1))+"s°g§d"+PhonemiseAvecRacine(ExpSecond.cap(2)); }
 else if (ExpMonsieur.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpMonsieur.cap(1))+"m°sj2"+PhonemiseAvecRacine(ExpMonsieur.cap(2)); }
 else if (ExpMessieurs.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpMessieurs.cap(1))+"mesj2"+PhonemiseAvecRacine(ExpMessieurs.cap(2)); }

 else if (ExpTele.indexIn(mot)  >=0 ) { mot="tele"+PhonemiseAvecRacine(ExpTele.cap(1)); }
 else if (ExpNoms.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpNoms.cap(1))+"n£"; }
 else if (ExpTechn.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpTechn.cap(1))+"tEkn"+PhonemiseAvecRacine(ExpTechn.cap(2)); }
 else if (ExpOrient.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpOrient.cap(1))+"orj@t"+PhonemiseAvecRacine(ExpOrient.cap(2)); }
 else if (ExpSupers.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpSupers.cap(1))+"sypER"; }
 else if (ExpEndum.indexIn(mot)>=0) { mot=PhonemiseAvecRacine(ExpEndum.cap(1))+"5dom" ;}
 else if (ExpSaint.indexIn(mot) >=0  ) { mot="s5t"+PhonemiseAvecRacine(ExpSaint.cap(1)+ExpSaint.cap(2)); }
 else if (ExpSous.indexIn(mot) >=0  ) { mot="suz"+PhonemiseAvecRacine(ExpSous.cap(1)+ExpSous.cap(2)); }
 else if (ExpVille.indexIn(mot)  >=0 ) { mot="vil"+PhonemiseAvecRacine(ExpVille.cap(1)); }
 else if (ExpVilles.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpVilles.cap(1))+"vil"; }
 else if (ExpAnti.indexIn(mot)  >=0 ) { mot="@ti"+PhonemiseAvecRacine(ExpAnti.cap(1)); }
 else if (ExpChore.indexIn(mot)  >=0 ) { mot="koRe"+PhonemiseAvecRacine(ExpChore.cap(1)); }
 else if (ExpAuto.indexIn(mot)  >=0 ) { mot="oto"+PhonemiseAvecRacine(ExpAuto.cap(1)); }
 else if (ExpTiers.indexIn(mot)  >=0 ) { mot="tjEr"; }
 else if (ExpTier.indexIn(mot)  >=0 ) { mot="tjEr"+PhonemiseAvecRacine(ExpTier.cap(1)); }
 else if (ExpGirls.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpGirls.cap(1))+"g9Rl"; }
 else if (ExpAfters.indexIn(mot)  >=0 ) { mot="aftER"+PhonemiseAvecRacine(ExpAfters.cap(1)); }
 else if (ExpGentilhom.indexIn(mot)  >=0 ) { mot="Z@tijom"+PhonemiseAvecRacine(ExpGentilhom.cap(1)); }
 else if (ExpDessus.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpDessus.cap(1))+"d°sy"+PhonemiseAvecRacine(ExpDessus.cap(2)); }
 else if (ExpDessous.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpDessous.cap(1))+"d°su"+PhonemiseAvecRacine(ExpDessous.cap(2));}
 else if (ExpSuspense.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpSuspense.cap(1))+"syspEns"+PhonemiseAvecRacine(ExpSuspense.cap(2)); }
 else if (ExpPoids.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpPoids.cap(1))+"pwa" ;}
 else if (ExpCamps.indexIn(mot)  >=0 ) { mot=PhonemiseAvecRacine(ExpCamps.cap(1))+"k@" ;}
 else { mot=Phonemise(mot); }
}
Debug(8,"PhonemiseAvecRacine : "+mot);
return(mot);
}



QString phonemise::Minuscule ( QString mot )
{
 mot.replace('A','a');
 mot.replace("À","à");
 mot.replace("Ä","ä");
 mot.replace("Â","â");
 mot.replace('B','b');
 mot.replace('C','c');
 mot.replace("Ç","ç");
 mot.replace('D','d');
 mot.replace('E','e');
 mot.replace("É","é");
 mot.replace("È","è");
 mot.replace("Ë","ë");
 mot.replace("Ê","ê");
 mot.replace('F','f');
 mot.replace('G','g');
 mot.replace('H','h');
 mot.replace('I','i');
 mot.replace('J','j');
 mot.replace('K','k');
 mot.replace('L','l');
 mot.replace('M','m');
 mot.replace('N','n');
 mot.replace('o','o');
 mot.replace("Ö","ö");
 mot.replace('P','p');
 mot.replace('Q','q');
 mot.replace('R','r');
 mot.replace('S','s');
 mot.replace('T','t');
 mot.replace('U','u');
 mot.replace("Ù","ù");
 mot.replace("Ü","ü");
 mot.replace("Û","û");
 mot.replace('V','v');
 mot.replace('W','w');
 mot.replace('X','x');
 mot.replace('Y','y');
 mot.replace('Z','z');
 return (mot);
}

QString phonemise::MinusculeSaufSigle( QString mot)
{
	if (mot.length()>=2)
	if ( mot[1].isLower()) return (mot.toLower());
	return (mot);
}

QString phonemise::PhonemiseMot  (QString mot)
{
mot=MinusculeSaufSigle(mot);
mot=SupprimePonctuation(mot);
mot=Exceptions(mot);
mot=FinMuette(mot);
mot=TraiteS(mot);
mot=TraiteK(mot);
mot=TraiteC(mot);
mot=TraiteQ(mot);
mot=TraiteG(mot);
mot=TraiteJ(mot);
mot=TraiteY(mot);
mot=TraiteA(mot);
mot=TraiteU(mot);
mot=TraiteW(mot);
mot=TraiteO(mot);
mot=TraiteI(mot);
mot=TraiteDoubleConsonne(mot);
mot=TraiteD(mot);
mot=TraiteF(mot);
mot=TraiteH(mot);
mot=TraiteL(mot);
mot=TraiteM(mot);
mot=TraiteN(mot);
mot=TraiteP(mot);
mot=TraiteR(mot);
mot=TraiteT(mot);
mot=TraiteX(mot);
mot=TraiteZ(mot);
mot=TraiteE(mot);
mot=TraiteTrema(mot);
mot=ChangeLettresFictives(mot);
Debug(10,mot);
return(mot);
}



QString phonemise::Phonemise  (QString mot)
{
 Debug(9,"Entree Phonemise :"+mot);
 QString retour;
 QStringList sousmot = mot.split(QRegExp("-| "));
 for (int i = 0; i < sousmot.size(); ++i) {
   Debug (11, "Phonemise sous mot :" + sousmot.at(i));
	retour+=PhonemiseMot(sousmot.at(i));
  }
 Debug(9,"Sortie Phonemise :"+retour);

 return(retour);
}


QString phonemise::Text2Phoneme(QString mot)
{
 Debug(9,"Text2Phoneme : "+mot);
 if ( mot =="" ) return (""); else return ( PhonemiseAvecRacine (mot));
}

void phonemise::DecoupePhrase (QString phrase)
{
//cette fonction découpe une phrase en prenant compte des voyelles en début de mot qui doivent
// être liées.
// amicale enfant => amicalenfant
// oiseau hautain => oiseau hautain
// sacrés livres => sacrés livres
// sacrés enfants => sacrésenfants
// sacré enfant => sacré enfant
	QString phrase1=SupprimePonctuation( phrase );
	phrase1.replace(QRegExp(" +")," ");
	QStringList list=phrase1.split(' ');
	QString mot=list.takeFirst();
	if ( list.empty() ) {
		PhraseDecoupee.append(mot);
		return ;
	}
	mot=MinusculeSaufSigle(mot);
	QString motsuivant=list.takeFirst();
	motsuivant=MinusculeSaufSigle(motsuivant);
	QRegExp rx("^[aàäâeéèëêiïîoôöuüüùyh]");
	QRegExp rxc("[aàäâeéèëêiïîoôöuüüùyh]$");
	QRegExp rxs("[aeiou]n$");
	QRegExp rxe("e$");
	if ( rx.indexIn(motsuivant) != -1 ) // commence par une voyelle
	{
		if ( rxc.indexIn(mot) == -1 || ( rxs.indexIn(mot) == -1 && mot.length() <4 )  ) // finit par une consonne mais pas un son en ain on etc  dans lequel il n'y a pas de liaison par contre un ane prend une liaison
		{
                        motsuivant=ExceptionMotSuivant(motsuivant);
                        mot=ExceptionMotPrecedent(mot);
                        mot.replace(QRegExp("d$"),"d");
                        mot.replace(QRegExp("s$"),"z");
			list.prepend (mot+motsuivant);
			QString ph=list.join(" ");
			DecoupePhrase(ph);
		}
		else // finit par une voyelle
		{
			if ( rxe.indexIn(mot) != -1 ) //finit par un e
			{
				mot.replace(rxe,"");
                                motsuivant=ExceptionMotSuivant(motsuivant);
                                mot=ExceptionMotPrecedent(mot);
				list.prepend(mot+motsuivant);
				QString ph=list.join(" ");
				DecoupePhrase(ph);
			}
			else  // finit par une voyelle qui n'est pas e
			{
				PhraseDecoupee.append(mot);
				list.prepend(motsuivant);
				QString ph=list.join(" ");
				DecoupePhrase(ph);
			}
		}

	}
	else // commence par une consonne
	{
		PhraseDecoupee.append(mot);
		list.prepend(motsuivant);
		QString ph=list.join(" ");
		DecoupePhrase(ph);
	}

}

QString phonemise::ExceptionMotPrecedent( QString chaine)
{
    if ( chaine == "est" ) return ("£") ;
    else return ( chaine) ;
}

QString phonemise::ExceptionMotSuivant( QString chaine)
{
    if ( chaine == "est" ) return ("£") ;
    else return ( chaine) ;
}

QString phonemise::PhonemiseBlock( QString block)
{
    // découpe un bloc de phrases pour effectuer la phonémisation de chaque ligne
    QStringList LignesPhonemisees;

    QStringList Lignes=block.split('\n');
    foreach ( QString ligne, Lignes)
    {
        PhraseDecoupee.clear();
        DecoupePhrase(ligne);
        QStringList PH;
        foreach ( QString mot , PhraseDecoupee)
            PH.append(Text2Phoneme(mot));
        QString ph=PH.join("");
        LignesPhonemisees.append(ph) ;
    }
  return (LignesPhonemisees.join("\n"));
}

int phonemise::NbSyllabe  (QString mot)
{
Debug(15,"NbSylabe : "+mot);
mot.replace(QRegExp("8i"),"i");
mot.replace(QRegExp("b"),"");
mot.replace(QRegExp("c"),"");
mot.replace(QRegExp("d"),"");
mot.replace(QRegExp("f"),"");
mot.replace(QRegExp("g",Qt::CaseInsensitive),"");
mot.replace(QRegExp("j"),"");
mot.replace(QRegExp("k"),"");
mot.replace(QRegExp("l"),"");
mot.replace(QRegExp("m"),"");
mot.replace(QRegExp("n"),"");
mot.replace(QRegExp("p"),"");
mot.replace(QRegExp("r",Qt::CaseInsensitive),"");
mot.replace(QRegExp("s",Qt::CaseInsensitive),"");
mot.replace(QRegExp("t"),"");
mot.replace(QRegExp("v"),"");
mot.replace(QRegExp("w"),"");
mot.replace(QRegExp("x"),"");
mot.replace(QRegExp("z",Qt::CaseInsensitive),"");
Debug(15,"Comptage : "+mot);
return (mot.length());
}


