#!/usr/bin/perl
# compare le résultat de la phonémisation par le module perl et par la procedure c++
use DBI;
use Lingua::FR::Phonemise  ;
use Term::ProgressBar;
use Benchmark ;
use strict;

my $db = DBI->connect("dbi:SQLite:../base/dicorime.db", "", "",
{RaiseError => 1, AutoCommit => 1});
my $all = $db->selectall_arrayref("SELECT ortho,PH  FROM dico");
my  $td0 = new Benchmark;
my $compt=0;
my $progress = Term::ProgressBar->new(180000);
foreach my $row (@$all) {
  $compt++;
   if ( $compt % 100 == 0 ) { $progress->update($compt); }

 my ($ortho,$PH) = @$row;
 my $cppPH=`../src/phoneme "$ortho" 2>&1` ;
 chomp( $cppPH);
 my $perlPH=Text2Phoneme($ortho) ;
if ( $perlPH ne $cppPH ) {
  print "$ortho => perl : $perlPH cpp : $cppPH PH : $PH\n"  ; 
}
}
  my $td1= new Benchmark;
  my $td = timediff($td1, $td0);
  print "Check ($compt):",timestr($td),"\n";
